var NAVTREE =
[
  [ "CARLsim", "index.html", [
    [ "Overview", "index.html", [
      [ "CARLsim 3", "index.html#main_carlsim", null ],
      [ "Getting Started", "index.html#main_getting_started", null ],
      [ "References", "index.html#main_ref", null ]
    ] ],
    [ "User Guide", "usergroup0.html", [
      [ "1. Getting Started", "ch1_getting_started.html", [
        [ "1.1 Pre-Installation", "ch1_getting_started.html#ch1s1_preinstallation", null ],
        [ "1.2 Installation", "ch1_getting_started.html#ch1s2_installation", null ],
        [ "1.3 Project Workflow", "ch1_getting_started.html#ch1s3_project_workflow", null ],
        [ "1.4 Uninstallation", "ch1_getting_started.html#ch1s4_uninstallation", null ]
      ] ],
      [ "2. Basic Concepts", "ch2_basic_concepts.html", [
        [ "2.1 General Workflow", "ch2_basic_concepts.html#ch2s1_general_workflow", null ]
      ] ],
      [ "3. Neurons, Synapses, and Groups", "ch3_neurons_synapses_groups.html", [
        [ "3.1 Neurons", "ch3_neurons_synapses_groups.html#ch3s1_neurons", null ],
        [ "3.2 Synapses", "ch3_neurons_synapses_groups.html#ch3s2_synapses", null ],
        [ "3.3 Groups", "ch3_neurons_synapses_groups.html#ch3s3_groups", null ]
      ] ],
      [ "4. Connections", "ch4_connections.html", [
        [ "4.1 Primitive Types", "ch4_connections.html#ch4s1_primitive_types", null ],
        [ "4.2 Library/Tools", "ch4_connections.html#ch4s2_library_tools", null ],
        [ "4.3 User-Defined", "ch4_connections.html#ch4s3_user_defined", null ],
        [ "4.4 Migrating from CARLsim 2.2", "ch4_connections.html#ch4s4_migrating_connect", null ]
      ] ],
      [ "5. Synaptic Plasticity", "ch5_synaptic_plasticity.html", [
        [ "5.1 Short-Term Plasticity", "ch5_synaptic_plasticity.html#ch5s1_short_term_plasticity", null ],
        [ "5.2 Spike-Timing Dependent Plasticity", "ch5_synaptic_plasticity.html#ch5s2_spike_timing_dependent_plasticity", null ],
        [ "5.3 Homeostasis", "ch5_synaptic_plasticity.html#ch5s3_homeostasis", null ],
        [ "5.4 References", "ch5_synaptic_plasticity.html#ch5s4_references", null ]
      ] ],
      [ "6. Input", "ch6_input.html", [
        [ "6.1 Generating Spikes", "ch6_input.html#ch6s1_generating_spikes", null ],
        [ "6.2 Generating Current", "ch6_input.html#ch6s2_generating_current", null ],
        [ "6.3 Visual Stimulus Toolbox", "ch6_input.html#ch6s3_visual_stimulus_toolbox", null ]
      ] ],
      [ "7. Monitoring", "ch7_monitoring.html", [
        [ "7.1 Spike Monitor", "ch7_monitoring.html#ch7s1_spike_monitor", null ],
        [ "7.2 Connection Monitor", "ch7_monitoring.html#ch7s2_connection_monitor", null ]
      ] ],
      [ "8. Saving and Loading", "ch8_saving_loading.html", [
        [ "8.1 saveSimulation", "ch8_saving_loading.html#ch8s1_savesimulation", null ],
        [ "8.2 loadSimulation", "ch8_saving_loading.html#ch8s2_loadsimulation", null ]
      ] ],
      [ "9. MATLAB Offline Analysis Toolbox (OAT)", "ch9_matlab_oat.html", [
        [ "9.1 Getting Started", "ch9_matlab_oat.html#ch9s1_getting_started", null ],
        [ "9.2 Network Monitor", "ch9_matlab_oat.html#ch9s2_network_monitor", null ],
        [ "9.3 Group Monitor", "ch9_matlab_oat.html#ch9s3_group_monitor", null ],
        [ "9.4 Connection Monitor", "ch9_matlab_oat.html#ch9s4_connection_monitor", null ],
        [ "9.5 Reading Raw Data", "ch9_matlab_oat.html#ch9s5_reading_raw_data", null ],
        [ "9.6 Migrating from CARLsim 2.2", "ch9_matlab_oat.html#ch9s6_migrating_scripts", null ]
      ] ],
      [ "10. ECJ", "ch10_ecj.html", [
        [ "10.1 Overview", "ch10_ecj.html#ch10s1_overview", null ],
        [ "10.2 Installation", "ch10_ecj.html#ch10s2_installation", null ],
        [ "10.3 Usage", "ch10_ecj.html#ch10s3_usage", null ],
        [ "10.4 References", "ch10_ecj.html#ch10s4_references", null ]
      ] ],
      [ "11. Regression Suite", "ch11_regression_suite.html", null ],
      [ "12. Advanced Topics", "ch12_advanced_topics.html", [
        [ "12.1 Best Practices", "ch12_advanced_topics.html#ch12s1_best_practices", null ],
        [ "12.2 Multi-GPU", "ch12_advanced_topics.html#ch12s2_multi_gpu", null ],
        [ "12.3 On-Line Weight Tuning", "ch12_advanced_topics.html#ch12s3_online_weight_tuning", null ]
      ] ]
    ] ],
    [ "Tutorial", "usergroup1.html", [
      [ "1. Basic Concepts", "tut1_basic_concepts.html", [
        [ "1.1 A Simple CARLsim Program", "tut1_basic_concepts.html#tut1s1_simple_prog", null ],
        [ "1.2 Network Output", "tut1_basic_concepts.html#tut1s2_network_output", null ],
        [ "1.3 Visualizing Network Activity", "tut1_basic_concepts.html#tut1s3_network_activity", null ]
      ] ],
      [ "2. 80-20 Random Spiking Network", "tut2_random_spnet.html", [
        [ "2.1 80-20 Networks", "tut2_random_spnet.html#tut2s1_8020_networks", null ],
        [ "2.2 Network Setup", "tut2_random_spnet.html#tut2s2_network_setup", null ],
        [ "2.3 Network Output", "tut2_random_spnet.html#tut2s3_network_output", null ],
        [ "2.4 Visualizing Network Activity", "tut2_random_spnet.html#tut2s4_network_activity", null ]
      ] ],
      [ "3. Plasticity", "tut3_plasticity.html", [
        [ "3.1 STDP and Homeostatic Synaptic Scaling", "tut3_plasticity.html#tut3s1_overview", null ],
        [ "3.2 Network Setup", "tut3_plasticity.html#tut3s2_network_setup", null ],
        [ "3.3 Network Output", "tut3_plasticity.html#tut3s3_network_output", null ],
        [ "3.4 Network Visualization", "tut3_plasticity.html#tut3s4_network_vis", null ]
      ] ],
      [ "4. Simple Weight Tuner", "tut4_simple_weight_tuner.html", [
        [ "4.1 Problem", "tut4_simple_weight_tuner.html#tut4s1_problem", null ],
        [ "4.2 Solution", "tut4_simple_weight_tuner.html#tut4s2_solution", null ]
      ] ],
      [ "5. Parameter Tuning Interface (PTI)", "tut5_pti.html", [
        [ "5.1 Introducton", "tut5_pti.html#tut5s1_intro", null ],
        [ "5.2 ECJ Parameter File", "tut5_pti.html#tut5s2_parameter_file", null ],
        [ "5.3 Experiment Class", "tut5_pti.html#tut5s3_experiment_class", null ],
        [ "5.3 Running the Simulation", "tut5_pti.html#tut5s4_run_sim", null ],
        [ "5.5 Output Files", "tut5_pti.html#tut5s5_output_files", null ]
      ] ]
    ] ],
    [ "Classes", null, [
      [ "Class List", "annotated.html", "annotated" ],
      [ "Class Index", "classes.html", null ],
      [ "Class Hierarchy", "hierarchy.html", "hierarchy" ],
      [ "Class Members", "functions.html", [
        [ "All", "functions.html", "functions_dup" ],
        [ "Functions", "functions_func.html", "functions_func" ],
        [ "Variables", "functions_vars.html", null ],
        [ "Enumerations", "functions_enum.html", null ],
        [ "Enumerator", "functions_eval.html", null ],
        [ "Related Functions", "functions_rela.html", null ]
      ] ]
    ] ],
    [ "Files", null, [
      [ "File List", "files.html", "files" ],
      [ "File Members", "globals.html", [
        [ "All", "globals.html", null ],
        [ "Functions", "globals_func.html", null ],
        [ "Variables", "globals_vars.html", null ],
        [ "Typedefs", "globals_type.html", null ],
        [ "Enumerations", "globals_enum.html", null ],
        [ "Enumerator", "globals_eval.html", null ],
        [ "Macros", "globals_defs.html", null ]
      ] ]
    ] ]
  ] ]
];

var NAVTREEINDEX =
[
"annotated.html",
"classConnectionMonitor.html#ae7e1476e14c4de7fd431d43f812d239c",
"structExpCurve.html#a211f28c97f7a844f9f22cdac0dc323f1"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function localStorageSupported()
{
  try {
    return 'localStorage' in window && window['localStorage'] !== null && window.localStorage.getItem;
  }
  catch(e) {
    return false;
  }
}


function storeLink(link)
{
  if (!$("#nav-sync").hasClass('sync') && localStorageSupported()) {
      window.localStorage.setItem('navpath',link);
  }
}

function deleteLink()
{
  if (localStorageSupported()) {
    window.localStorage.setItem('navpath','');
  } 
}

function cachedLink()
{
  if (localStorageSupported()) {
    return window.localStorage.getItem('navpath');
  } else {
    return '';
  }
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does not work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  var level=-1;
  var n = node;
  while (n.parentNode) { level++; n=n.parentNode; }
  if (node.childrenData) {
    var imgNode = document.createElement("img");
    imgNode.style.paddingLeft=(16*level).toString()+'px';
    imgNode.width  = 16;
    imgNode.height = 22;
    imgNode.border = 0;
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        node.plus_img.src = node.relpath+"ftv2pnode.png";
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
    imgNode.src = node.relpath+"ftv2pnode.png";
  } else {
    var span = document.createElement("span");
    span.style.display = 'inline-block';
    span.style.width   = 16*(level+1)+'px';
    span.style.height  = '22px';
    span.innerHTML = '&#160;';
    domNode.appendChild(span);
  } 
}

var animationInProgress = false;

function gotoAnchor(anchor,aname,updateLocation)
{
  var pos, docContent = $('#doc-content');
  if (anchor.parent().attr('class')=='memItemLeft' ||
      anchor.parent().attr('class')=='fieldtype' ||
      anchor.parent().is(':header')) 
  {
    pos = anchor.parent().position().top;
  } else if (anchor.position()) {
    pos = anchor.position().top;
  }
  if (pos) {
    var dist = Math.abs(Math.min(
               pos-docContent.offset().top,
               docContent[0].scrollHeight-
               docContent.height()-docContent.scrollTop()));
    animationInProgress=true;
    docContent.animate({
      scrollTop: pos + docContent.scrollTop() - docContent.offset().top
    },Math.max(50,Math.min(500,dist)),function(){
      if (updateLocation) window.location.href=aname;
      animationInProgress=false;
    });
  }
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath($(location).attr('pathname'));
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : "javascript:void(0)"; 
      a.onclick = function(){
        storeLink(link);
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var anchor = $(aname);
        gotoAnchor(anchor,aname,true);
      };
    } else {
      a.href = url;
      a.onclick = function() { storeLink(link); }
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var aname = $(location).attr('hash');
  var anchor = $(aname);
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+
               window.location.hash.substring(1)+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parents().slice(2).prop('tagName')=='TR') {
    glowEffect(anchor.parents('div.memitem'),1000); // enum value
  } else if (anchor.parent().attr('class')=='fieldtype'){
    glowEffect(anchor.parent().parent(),1000); // struct field
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
  gotoAnchor(anchor,aname,false);
}

function selectAndHighlight(hash,n)
{
  var a;
  if (hash) {
    var link=stripPath($(location).attr('pathname'))+':'+hash.substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  if ($('#nav-tree-contents .item:first').hasClass('selected')) {
    $('#nav-sync').css('top','30px');
  } else {
    $('#nav-sync').css('top','5px');
  }
  showRoot();
}

function showNode(o, node, index, hash)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index,hash);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).css({'display':'block'});
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1,hash);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index,hash); // retry with child node expanded
          },true);
        } else {
          var rootBase = stripPath(o.toroot.replace(/\..+$/, ''));
          if (rootBase=="index" || rootBase=="pages" || rootBase=="search") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(hash,n);
        }
      }
    }
  } else {
    selectAndHighlight(hash);
  }
}

function removeToInsertLater(element) {
  var parentNode = element.parentNode;
  var nextSibling = element.nextSibling;
  parentNode.removeChild(element);
  return function() {
    if (nextSibling) {
      parentNode.insertBefore(element, nextSibling);
    } else {
      parentNode.appendChild(element);
    }
  };
}

function getNode(o, po)
{
  var insertFunction = removeToInsertLater(po.li);
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
  insertFunction();
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = $.extend(true, [], nti ? nti : navTreeSubIndices[subIndex][root]);
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0, hash);
  }
}

function navTo(o,root,hash,relpath)
{
  var link = cachedLink();
  if (link) {
    var parts = link.split('#');
    root = parts[0];
    if (parts.length>1) hash = '#'+parts[1];
    else hash='';
  }
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
    //root=root.replace(/_source\./,'.'); // source link to doc link
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (i==-1) { i=0; root=NAVTREE[0][1]; } // fallback: show index
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function showSyncOff(n,relpath)
{
    n.html('<img src="'+relpath+'sync_off.png" title="'+SYNCOFFMSG+'"/>');
}

function showSyncOn(n,relpath)
{
    n.html('<img src="'+relpath+'sync_on.png" title="'+SYNCONMSG+'"/>');
}

function toggleSyncButton(relpath)
{
  var navSync = $('#nav-sync');
  if (navSync.hasClass('sync')) {
    navSync.removeClass('sync');
    showSyncOff(navSync,relpath);
    storeLink(stripPath2($(location).attr('pathname'))+$(location).attr('hash'));
  } else {
    navSync.addClass('sync');
    showSyncOn(navSync,relpath);
    deleteLink();
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  if (localStorageSupported()) {
    var navSync = $('#nav-sync');
    if (cachedLink()) {
      showSyncOff(navSync,relpath);
      navSync.removeClass('sync');
    } else {
      showSyncOn(navSync,relpath);
    }
    navSync.click(function(){ toggleSyncButton(relpath); });
  }

  $(window).load(function(){
    navTo(o,toroot,window.location.hash,relpath);
    showRoot();
  });

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath($(location).attr('pathname'))+':'+
                               $(location).attr('hash').substring(1);
         a=$('.item a[class$="'+clslink+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2($(location).attr('pathname'));
       navTo(o,link,$(location).attr('hash'),relpath);
     } else if (!animationInProgress) {
       $('#doc-content').scrollTop(0);
       $('.item').removeClass('selected');
       $('.item').removeAttr('id');
       navTo(o,toroot,window.location.hash,relpath);
     }
  })
}

